;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;=  This is Blue's entry to the Hugi-Size-Coding-Competition #2              =
;-                                                                           -
;=  contact me trough e-mail: blue@cs.tu-berlin.de                           =
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;=  use TASM to compile it ...                                               =
;-                                                                           -
;=  Size-History: 617->596->580->567->557->547->542                          =
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
IDEAL
P386

;-----------------------------------------------------------------------------
SEGMENT CompoCode PARA PUBLIC USE16
ASSUME cs:CompoCode,ds:CompoCode
ORG 100h

Main:
 mov   si,OFFSET TextData
 mov   bx,OFFSET CharTab-24
 lea   di,[bx+si]			; mov   di,OFFSET DecodedText
 cwd					; xor   dx,dx - ax should be zero
 push  di
 DecodeLoop:
 
  mov   cl,3				; write spaces
  call  GetBits
  xchg  cx,ax				; mov   cx,ax
  mov   al,' '
  shr   cx,1
  rep   stosb  
  jnc   EnterHere
   call  Get5Bits
   push  si
   push  dx
   cwd					; xor   dx,dx - ax is positiv
   mov   si,OFFSET WordData
   push  di
   push  bp
   add   cl,al
   SearchLoop:
    jnz   WordNotFound
     pop   bp
     pop   di
     stc
     EnterHere:
     pushf
    WordNotFound:
    ;PROC DecodeChars
    push  cx
    mov   cl,3
    call  GetBits
    xchg  cx,ax				; mov   cx,ax
    inc   cx
    CharLoop:
     push  cx
     call  Get5Bits
     pop   cx
     dec   ax
     jnz   NoBigChar
      mov   bp,'A'+1
      jmp   CharDone
     NoBigChar:
     cmp   al,24
     jl    NoSpecialChar
      xlatb
     NoSpecialChar:
     add   ax,bp
     mov   bp,'a'+1
     stosb 
     CharDone:
    loop  CharLoop
    pop   cx
    ;ENDP DecodeChars
    sub   cl,bh				; sub cl,1 - but bh should be 1 
   jnc   SearchLoop
   popf
   jnc   DecodeDone
    pop   dx
    pop   si
  DecodeDone:
  cmp   si,OFFSET TextEnd
 jb    DecodeLoop 

 pop   di
 push  di
 mov   dl,20
 EnterLoop:
  mov   cl,44
  mov   al,'?'
  repne scasb
  mov   ax,0A0Dh
  stosw
  dec   dx				; dec dl - but dh should be zero
 jnz   EnterLoop
 add   di,19
 stosw
 pop   dx
 aas					; mov   ah,09h
 int   21h
; ret

;-----------------------------------------------------------------------------
;do : returns al-bits from ds:si
;in : number of wanted bits in al
;out: bits in ax
;-----------------------------------------------------------------------------
Get5Bits:
 mov   cl,5
PROC GetBits
 xor   ax,ax
 BitLoop:
  or    dl,dl
  jnz   NoNewByte
   inc   dx
   mov   dh,[BYTE PTR si]
   inc   si
  NoNewByte:
  shl   dx,1				; get one bit
  adc   ax,ax				; shld  ax,dx,1
 Loop  BitLoop
 ret
ENDP GetBits
;-----------------------------------------------------------------------------

LABEL CharTab
 db 'B'-'a'-1
 db ' '-'a'-1
 db '.'-'a'-1
 db ','-'a'-1
 db '-'-'a'-1
 db '?'-'a'-1
 db '$'-'A'-1

 LABEL WordData
  db 175,  88,  27,  57,  32,  68, 138, 103
  db  37,  90,  42, 134, 154, 204, 232, 105
  db 164, 230, 112,  77,   8,  13,  51, 113
  db  67,  75, 139,   8,   8, 204, 236, 174
  db 112, 206, 194,  98,  68,   5, 173, 150
  db  46, 101, 121,  28, 245, 145, 173,  10
  db  36, 116, 206,  72, 224,  53,  12,   2
  db 228, 136,   9, 197,  33, 163, 146, 195
  db 168, 128, 209, 150, 205, 176,  13, 198
  db  26,  10,  82,  68, 149, 235,   0, 137
  db  40,  25,  57, 132, 118,   6,  36, 214
  db 138, 146, 225, 212, 140, 182

 LABEL TextData
  db 192,  36,  20,  52,  73, 185, 171, 197
  db  27,  35,  45,  50,  84, 145,  23, 149
  db  26, 180,  24, 243, 103,  84,  71,   3
  db  76,  69,   4,  72, 204,   5,  10,  48
  db  19,  36,  67,  64,  23,  42, 154,  38
  db 166, 130, 118, 178, 201, 166, 116,  75
  db  72, 147,  19, 104,  96, 147, 155,  74
  db 220, 210, 147, 169,  22, 182, 210, 225
  db 177, 161,  57, 132, 147, 122, 134, 137
  db   8, 218,   2, 199,   0,  56, 226, 228
  db 230,  47,  52, 202,  74, 110, 148,  16
  db 186,  54,  78, 181,  46, 108, 174, 148
  db   5, 137,  53, 214, 102, 118,  90,  68
  db  38, 172, 124,  49,  32, 179, 113, 249
  db 171,   2, 100, 143,  35,   2,  35, 203
  db 121, 229,  70, 200, 232, 105,  42, 104
  db 170, 168,  97, 147, 166,  67,  30, 232
  db 204,   7,   9,  21, 209, 110,  99, 100
  db   3, 208,   7, 136, 182, 133, 229, 232
  db 225, 213, 165, 238,  23,  54, 138, 168
  db 177, 242, 237, 133,  88, 129,  13, 198
  db 223,  40,  99,  28, 113, 187, 203, 186
  db  24, 234,  72, 226,  49,  57,  99, 168
  db 150, 200, 108, 201,  18, 203,  39, 182
  db  24,  64, 179, 213,  44,   8, 179, 111
  db 151, 116,  42, 172, 149,  34, 248, 238
  db 228,   4, 152,  84,  58,  22, 188,  22
  db  59,  71, 100,  45, 113, 149,  13,  28
  db  78, 164, 226,  59, 173,  97, 125,  81
  db 115, 116, 113, 106, 210, 246,  88, 208
  db 165, 142, 129,  29,  53,  33, 163, 105
  db 157, 235,   0, 137, 161, 185, 217, 248
  db  47,   0,  31, 142,  15, 205,  15, 169
  db 178, 130,  59, 139, 253, 229, 133, 243
  db  69, 236, 144, 162,  38,  71, 163, 138
  db 251, 248, 179,  73, 183,  88,  35,  35
  db 144, 177,  39,  32,  48, 147, 189,  96
  db 105,  39, 174, 177,  53,  22,  65, 240

LABEL TextEnd

ENDS CompoCode
;-----------------------------------------------------------------------------
END Main
;-----------------------------------------------------------------------------
