;------------------------------------------;
; Text UnPacker v2.2 by Picard / Hydrogen  ;
;                                          ;
; mailto:picard@telnet.hu                  ;
;------------------------------------------;
.386p
code segment public use16 'code'
assume cs:code,ds:code,ss:code
;assume si:0100h
org 100h
start:
				; STAGE 1
				; 7bytes lookup table:
	push	si		;   newline   (negative byte) - 'Z'
	ror     dl,cl		;   , $          (ascii code) - 'Z'
	rol	si,cl		;   - space      (ascii code) - 'Z'
	mov	ah,0C5h		;   . ?          (ascii code) - 'Z' - 32
	pop	bx		; bx = 100h
	mov	bp,(offset data-offset start)*8
	mov	di,bp           ; di = free space below 0x8000
	push    di
decode:	mov     cl,11		; get 11 bits
bitloop:bt      [bx],bp
	inc     bp
	rcr	ax,1            ; set msb in ax
	loop    bitloop
	shr	ax,6            ; first bit to cflag, others stay in ax
	jc	move		; move token ?
	sub	bp,5		; go back 5bits
	and	al,31           ; only 5bit used (11-1-5=5)
	sub     al,25		; special char?
	js      abc
	xlat                    ; lookup special char from start[0..6]
abc:    add     al,90		; add 'Z'
	stosb
	jmp     ok
move:   mov	cl,3            ; mincount = 3
	shr	ax,1		; check next bit
	jc	size9		; type0 or type1 token?
	sub	bp,cx           ; go back 3bits
	and	ax,63		; only 6bit used (11-1-1-3=6)
	dec	cx		; mincount = 2
size9:	mov     si,di		; source = (current pos) - (data from ax)
	sub     si,ax
moving: rep movsb               ; first move mincount
	bt      [bx],bp
	inc     bp
	jc      moving+1        ; move one bytes until 0 bit found
ok:     or      di,di          
	jns     decode		; loop until di >= 0x8000

				; STAGE 2
	pop     si              ; si=stage1,di>=0x8000,bx=0x100,dx=0
	push    di
	cwd
postadj:mov     cl,44		; assume line will be 44 chars
line:   lodsb
	or	al,dl		; case dl=0  nothing done, upper case letters
				; case dl=32
				;   case al=A..Z -> a..z
				;   case al=, $ - space -> nothing done
				;   case al=.-32 ?-32 -> normal . ?
	js	newline         ; if special negative byte, break loop
	stosb			; store adjusted char

	add	dl,[si-1]       ; calc new dl
	shr	dl,1            ; when al=A..Z -> dl=32
	and	dl,20h          ; when al=, $ - space -> dl=dl
				; when al=.-32 ?-32 -> dl=0
	loop    line
newline:mov     ax,0A0Dh        ; store newline chars
	stosw
	dec     bx              ; line counter
	jne     postadj

	pop     dx              ; print text
	mov     ah,9
	int     21h
	ret
data:

code ends
end start
